<?php

return array(

  'integration-mode'   => 'pro',
  'powered-by-themeco' => __( 'Powered by Themeco', '__x__' ),

  // Messaging
  'welcome-app'       => __( '<strong>Howdy!</strong> What would you like to launch?', '__x__' ),
  'save'              => __( 'Save', '__x__' ),
  'apply'             => __( 'Apply', '__x__' ),
  'loading'           => __( 'Loading&hellip;', '__x__' ),
  'unauthorized'      => __( 'You don&apos;t have permission to do that.', '__x__' ),
  'exit-to-dashboard' => __( 'Exit to Dashboard', '__x__' ),
  'unsaved-warning'   => __( 'You have unsaved changes that will be lost if you continue. Are you sure you wish to leave?', '__x__' ),

  'streamline-nav-unsaved'   => __( 'Would you like to edit this {{context}}? You have unsaved changes that will be lost if you continue.', '__x__' ),
  'streamline-nav'           => __( 'Would you like to edit this {{context}}? You can safely leave as there are no unsaved changes.', '__x__' ),

  // General Purpose
  'copy-of'    => __( 'Copy of {{title}}', '__x__' ),
  'copy-of-numeric'    => __( '{{title}} ({{index}})', '__x__' ),
  'indexed' => __( '{{label}} {{index}}', '__x__'),
  'search' => __( 'Search', '__x__' ),
  'back-to' => __( 'Back to {{to}}', '__x__' ),
  'item' => __( 'Item', '__x__'),
  'add-item' => __( 'Add Item', '__x__' ),
  'add-label' => __( 'Add {{label}}', '__x__' ),

  // Formatting
  'formatting-colon' => __( '{{{prefix}}}: {{{content}}}', '__x__'),

  // Preview Sizer
  'preview-sizer-abbr-xl' => __( 'XL', '__x__' ),
  'preview-sizer-abbr-lg' => __( 'LG', '__x__' ),
  'preview-sizer-abbr-md' => __( 'MD', '__x__' ),
  'preview-sizer-abbr-sm' => __( 'SM', '__x__' ),
  'preview-sizer-abbr-xs' => __( 'XS', '__x__' ),
  'preview-sizer-desc-xl'  => __( '1200px &amp; Up', '__x__' ),
  'preview-sizer-desc-lg'  => __( '980px-1199px', '__x__' ),
  'preview-sizer-desc-md'  => __( '768px-979px', '__x__' ),
  'preview-sizer-desc-sm'  => __( '481px-767px', '__x__' ),
  'preview-sizer-desc-xs'  => __( '480px &amp; Smaller', '__x__' ),

  // Titles
  'home.title'          => __( 'Home', '__x__' ),
  'options.title'       => __( 'Theme Options', '__x__' ),
  'headers.title'       => __( 'Headers', '__x__' ),
  'footers.title'       => __( 'Footers', '__x__' ),
  'content.title'       => __( 'Content', '__x__' ),
  'fonts.title'         => __( 'Fonts', '__x__' ),
  'managers.title'      => __( 'Managers', '__x__' ),
  'templates.title'     => __( 'Templates', '__x__' ),
  'layout.title'        => __( 'Layout', '__x__' ),
  'inspector.title'     => __( 'Inspector', '__x__' ),
  'elements.title'      => __( 'Elements', '__x__' ),
  'settings.title'      => __( 'Settings', '__x__' ),
  'global-blocks.title' => __( 'Global Blocks', '__x__' ),

  'template-manager.title'       => __( 'Template Manager', '__x__' ),
  'design-cloud.title'           => __( 'Design Cloud', '__x__' ),
  'font-manager.title'           => __( 'Font Manager', '__x__' ),
  'color-manager.title'          => __( 'Color Manager', '__x__' ),
  'element-manager.title'        => __( 'Element Manager', '__x__' ),
  'template-manager-short.title' => __( 'Template', '__x__' ),
  'font-manager-short.title'     => __( 'Font', '__x__' ),
  'color-manager-short.title'    => __( 'Color', '__x__' ),
  'element-manager-short.title'  => __( 'Element', '__x__' ),


  // Inspector
  'inspector.na-title' => __( 'Nothing Selected', '__x__' ),
  'inspector.na-message' => __( 'Click an element in the site preview, or use the magnifying glass icon on elements in the <strong>Layout</strong> pane.', '__x__' ),
  'inspector.search'   => __( 'Search Inspector...', '__x__' ),
  'inspector.apply-preset-warning' => __( 'This action will replace all element styling. Proceed?', '__x__' ),

  // Elements
  'elements.search'            => __( 'Search Elements', '__x__' ),
  'elements.nothing-found'     => __( 'No Elements Found', '__x__' ),
  'elements.nothing-found-msg' => __( 'Try refining your search to locate your desired element.', '__x__' ),

  // Controls
  'controls-previous-missing'                 => __( 'Previous Value Unavailable', '__x__' ),
  'controls-font-family-select'               => __( '{{family}} ({{source}})', '__x__' ),
  'controls-text-editor-click-to-edit'        => __( 'Click to Edit', '__x__' ),
  'controls-text-editor-edit-text'            => __( 'Edit Text', '__x__' ),
  'controls-text-editor-html-mode-label'      => __( 'HTML', '__x__' ),
  'controls-text-editor-rich-text-mode-label' => __( 'Rich Text', '__x__' ),

  'controls-tooltip-top' => __( 'Top', '__x__' ),
  'controls-tooltip-right' => __( 'Right', '__x__' ),
  'controls-tooltip-bottom' => __( 'Bottom', '__x__' ),
  'controls-tooltip-left' => __( 'Left', '__x__' ),

  // Notifications
  'notification-notice'  => __( 'Hey!', '__x__' ),
  'notification-success' => __( 'Awesome!', '__x__' ),
  'notification-error'   => __( 'Uh oh!', '__x__' ),

  'notification-refreshing-preview'   => __( 'Refreshing preview.', '__x__' ),
  'notification-refreshing-preview-save-reminder'   => __( 'Refreshing preview. Don\'t forget to save.', '__x__' ),


  // Assignments
  'assignments.global'               => __( 'Global', '__x__' ),
  'assignments.unassigned'           => __( 'Unassigned', '__x__' ),
  'assignments.tagged'               => __( '{{tag}}: {{title}}', '__x__' ),
  'assignments.multiple-assignments' => __( 'Multiple Assignments', '__x__' ),

  // Elements
  'elements-confirm-delete' => __( 'Are you sure you want to delete this {{title}}?', '__x__' ),
  'elements-confirm-erase' => __( 'Are you sure you want to delete this element&apos;s contents?', '__x__' ),
  'elements-undefined-preview' => __( 'This element could not render because its definition is missing. You might need to activate a plugin.', '__x__' ),
  'elements-preview-unavailable' => __( 'No Preview Available (<a target="_blank" href="{{url}}">View Live</a>)', '__x__' ),
  'elements-undefined-inspector-title' => __( 'Undefined Element', '__x__' ),
  'elements-undefined-inspector-message' => __( 'The definition for this element could not be located. You may need to activate a plugin. The type declared for this element is: <strong>{{type}}</strong>', '__x__' ),

  // Presets
  'presets.placeholder'     => __( 'Nothing Selected', '__x__' ),
  'presets.na'              => __( 'No Presets', '__x__' ),
  'presets.save'            => __( 'Save Preset', '__x__' ),
  'presets.apply'           => __( 'Apply Preset', '__x__' ),
  'presets.replace-content' => __( 'Replace Content', '__x__' ),
  'presets.apply-confirm'   => __( 'Yes, Apply', '__x__' ),
  'presets.apply-decline'   => __( 'No thanks', '__x__' ),

  // Confirm
  'confirm-yep'  => __( 'Yes, Proceed', '__x__' ),
  'confirm-nope' => __( 'No, Go Back', '__x__' ),
  'confirm-back' => __( 'Back', '__x__' ),


  // Options
  'options.launch-headers' => __( 'Launch Header Builder', '__x__' ),
  'options.launch-footers' => __( 'Launch Footer Builder', '__x__' ),
  'options.confirm-header-switch-back' => __( 'Are you sure you wish to switch back to Original Headers? This will unassign remove your global Pro Header.', '__x__' ),
  'options.confirm-footer-switch-back' => __( 'Are you sure you wish to switch back to Original Footers? This will unassign remove your global Pro Footer.', '__x__' ),

  // Manage
  'manage.welcome' => __( 'Manage all of your templates, fonts, and colors from one central location!', '__x__' ),

  // Templates
  'templates.blank-welcome'   => __( 'Begin with a blank slate.', '__x__'),

  'templates.download-label' => array(
    'one' => __( 'Download Template', '__x__'),
    'other' => __( 'Download {{count}} Templates', '__x__'),
  ),

  'templates.delete-label' => array(
    'one' => __( 'Delete Template', '__x__'),
    'other' => __( 'Delete {{count}} Templates', '__x__'),
  ),

  'templates.delete-popover' => array(
    'one' => __( 'Are you sure you want to delete the selected template?', '__x__'),
    'other' => __( 'Are you sure you want to delete the {{count}} selected templates?', '__x__'),
  ),

  'templates.filter-all' => __( 'All', '__x__'),
  'templates.filter-header' => __( 'Headers', '__x__'),
  'templates.filter-footer' => __( 'Footers', '__x__'),
  'templates.filter-content' => __( 'Content', '__x__'),
  'templates.filter-preset' => __( 'Presets', '__x__'),
  'templates.filter-my-templates' => __( 'My Templates', '__x__'),
  'templates.filter-themeco-templates' => __( 'Themeco Templates', '__x__'),
  'templates.design-cloud'   => __( 'Design Cloud', '__x__'),

  'templates.type-header'    => __( 'Header', '__x__'),
  'templates.type-footer'    => __( 'Footer', '__x__'),
  'templates.type-content'   => __( 'Content', '__x__'),
  'templates.type-preset'    => __( 'Preset', '__x__'),
  'templates.subtype-format' => __( '<strong>{{type}}</strong>: {{subtype}}', '__x__'),

  'templates.upload-error'   => __( 'Sorry! Your file is not properly formatted.', '__x__' ),

  'templates.element-defaults-save' => __( 'Element defaults updated!', '__x__' ),
  'templates.element-defaults-error' => __( 'Unable to save element default.', '__x__' ),

  // Fonts
  'fonts.new-title' => __( 'Font {{index}}', '__x__' ),

  // Colors
  'colors.new-title' => __( 'Color {{index}}', '__x__' ),
  'colors.empty-message' => __( 'Click "Add New" to create a color selection.', '__x__' ),


  // Font Weights
  'font-weight.100'       => __( '100 &ndash; Ultra Light', '__x__' ),
  'font-weight.100italic' => __( '100 &ndash; Ultra Light (Italic)', '__x__' ),
  'font-weight.200'       => __( '200 &ndash; Light', '__x__' ),
  'font-weight.200italic' => __( '200 &ndash; Light (Italic)', '__x__' ),
  'font-weight.300'       => __( '300 &ndash; Book', '__x__' ),
  'font-weight.300italic' => __( '300 &ndash; Book (Italic)', '__x__' ),
  'font-weight.400'       => __( '400 &ndash; Regular', '__x__' ),
  'font-weight.400italic' => __( '400 &ndash; Regular (Italic)', '__x__' ),
  'font-weight.500'       => __( '500 &ndash; Medium', '__x__' ),
  'font-weight.500italic' => __( '500 &ndash; Medium (Italic)', '__x__' ),
  'font-weight.600'       => __( '600 &ndash; Semi-Bold', '__x__' ),
  'font-weight.600italic' => __( '600 &ndash; Semi-Bold (Italic)', '__x__' ),
  'font-weight.700'       => __( '700 &ndash; Bold', '__x__' ),
  'font-weight.700italic' => __( '700 &ndash; Bold (Italic)', '__x__' ),
  'font-weight.800'       => __( '800 &ndash; Extra Bold', '__x__' ),
  'font-weight.800italic' => __( '800 &ndash; Extra Bold (Italic)', '__x__' ),
  'font-weight.900'       => __( '900 &ndash; Ultra Bold', '__x__' ),
  'font-weight.900italic' => __( '900 &ndash; Ultra Bold (Italic)', '__x__' ),

  // Custom Code
  'code-editors.custom_css_placeholder' => __( "/*\nNo need for style tags here;\nsimply get started by writing\nCSS! Watch as your changes\nare reflected live in the\npreview area. Have fun!\n*/\n\n", 'cornerstone' ),
	'code-editors.custom_js_placeholder'  => __( "//\n// No need to add script tags\n// here; simply get started\n// by writing JavaScript!\n// Click \"Run\" to see your\n// changes applied :)\n//\n\n", 'cornerstone' ),

  // Choices
  'choices.menu-named'    => __('Menu: %s', '__x__'),
  'choices.menu-location' => __('Location: %s', '__x__'),

  // Sort
  'sort.new-old' => __( 'Newest', '__x__' ),
  'sort.old-new' => __( 'Oldest', '__x__' ),
  'sort.a-z'     => __( 'A-Z', '__x__' ),
  'sort.z-a'     => __( 'Z-A', '__x__' ),
  'sort.popular' => __( 'Popular', '__x__' ),

  // Actions
  'duplicate'     => __( 'Duplicate', '__x__' ),
	'delete'        => __( 'Delete', '__x__' ),
	'really-delete' => __( 'Really Delete?', '__x__' ),
  'erase'         => __( 'Erase', '__x__' ),
  'really-erase'  => __( 'Really Erase?', '__x__' ),
  'manage-layout' => __( 'Manage Layout', '__x__' ),

  // Errors
  'preview-error.missing-zone.x_masthead' => __('No suitable preview area found. This is most common when you are using a "No Header" page template. Try changing the page template, or assigning this header to a context where the template allows the header output.', '__x__'),
  'preview-error.missing-zone.x_colophon' => __('No suitable preview area found. This is most common when you are using a "No Footer" page template. Try changing the page template, or assigning this footer to a context where the template allows the footer output.', '__x__'),
  'preview-error.missing-zone.cs_content' => __('No suitable preview area found. This could happen when a third party plugin is overrinding the content area.', '__x__'),

  'preview-error.load.default'         => __('The preview could not load. This is most often related to a plugin conflict or aggressive page cacheing. Checking the developer console for errors could indicate what went wrong.', '__x__'),
  'preview-error.load.https-mismatch'  => __('The preview could not load due to a http/https mismatch. Please check that HTTPS is properly configured on your site.', '__x__'),
  'preview-error.load.cross-origin'    => __('The preview could not load due to misconfigured URLs. This could happen if you are using multiple environments and the site URL was not updated after migrating.', '__x__'),
  'preview-error.load.incomplete'      => __('The preview could not load due to the iframe response being incomplete. This is most often related to a plugin conflict, or customizations introducing a PHP error.', '__x__'),
  'preview-error.load.timeout'         => __('The preview was unresponsive after loading. This is most often related to a plugin conflict or aggressive page cacheing.', '__x__'),

  'preview-error.loading.incomplete-html' => __('The preview HTML did not include a closing </html> tag. It may fail to load or work properly.', '__x__'),

  // Preferences
  'preferences.title'          => __('Preferences', '__x__'),
  'preferences.description'    => __('Configure how Pro should look and behave. These settings are specific to your user account.', '__x__'),
  'preferences.wp-toolbar-on'  => __('The WordPress toolbar will be shown on next reload.', '__x__'),
  'preferences.wp-toolbar-off' => __('The WordPress toolbar will be hidden on next reload.', '__x__'),
  'preferences.saved'          => __('Preferences saved!', '__x__'),
  'preferences.save-error'     => __('Unable to save preferences.', '__x__'),

  // Skeleton Mode
  'skeleton-item-handle' => __("{{type}} - {{title}}", '__x__')

);
