<?php

/**
 * Localize strings for javascript
 */

return array(

  // General
  'welcome'         => __('<strong>It&apos;s buildin&apos; time!</strong> Make a selection from the workspace to see a preview.', '__x__'),
  'section'         => __( 'Section', '__x__' ),
  'sections'        => __( 'Sections', '__x__' ),
  'section-numeric' => __( 'Section %s', '__x__' ),
  'section-format'  => __( 'Section &ndash; %s', '__x__' ),
  'rows'            => __( 'Rows', '__x__' ),
  'row'             => __( 'Row', '__x__' ),
  'row-numeric'     => __( 'Row %s', '__x__' ),
  'column'          => __( 'Column', '__x__' ),
  'column-format'   => __( 'Column &ndash; %s', '__x__' ),

  // Index
  'search-by-title'          => __( 'Search by Title', '__x__' ),
  'no-content-found'         => __( 'No Content Found', '__x__' ),
  'no-content-found-message' => __( 'Try refining your search to locate your desired content.', '__x__' ),

  // Footer
  'footer-button-save'       => __( 'Save', '__x__' ),
  'footer-dashboard-confirm' => __( 'Are you sure you wish to return to the Dashbord?', '__x__' ),

  // Layout
  'layout-heading'                => __( 'Layout', '__x__' ),
  'layout-return'                 => __( 'Back to Layout', '__x__' ),
  'layout-add-row'                => __( 'Add Row', '__x__' ),
  'layout-add-section'            => __( 'Add Section', '__x__' ),
  'layout-templates'              => __( 'Templates', '__x__' ),
  'layout-load-template'          => __( 'Load Template', '__x__' ),
  'layout-save-template'          => __( ' Save Template', '__x__' ),


  'layout-section-delete-confirm' => __( 'Are you sure you want to delete this section along with all its contents?', '__x__' ),
  'layout-row-delete-confirm'     => __( 'Are you sure you want to delete this row along with all its contents?', '__x__' ),
  'layout-row-subtext'            => __( 'Click a row to manage columns. Drag to reorder.', '__x__' ),
  'layout-info-title'             => __( 'Just getting started?', '__x__' ),
  'layout-info-description'       => __( 'Add a section then click on it to manage column layouts or drag it to reorder.', '__x__' ),

  // Layout - Columns
  'columns-info-title'       => __( 'Want to add content?', 'cornerstone' ),
  'columns-info-description' => __( 'Choose a layout, click the <strong class="glue">{{icon}} Elements</strong> icon above, then drag elements into a column.', 'cornerstone' ),
  'columns-layout-custom'    => __( 'Custom', 'cornerstone' ),
  'columns-layout-label'     => __( 'Column Layout', 'cornerstone' ),
  //'columns-layout-tooltip'   => __( 'Choose from one of our predefined column layouts, or specify your own using the input below. Columns cannot be any smaller than 1/6 and must add up to a whole.', 'cornerstone' ),
  'columns-order-label'      => __( 'Column Order', 'cornerstone' ),
  //'columns-order-tooltip'    => __( 'Click and drag to reorder your columns.', 'cornerstone' ),
  'columns-erase-confirm'    => __( 'This will remove all elements from this column. Are you sure you want to continue?', 'cornerstone' ),


  // Layout - Templates
  'templates-info-title'        => __( 'Blocks and pages?', '__x__' ),
  'templates-info-description'  => __( '<strong>Blocks</strong> are appended to your content, whereas <strong>Pages</strong> will replace your content.', '__x__' ),
  'templates-save'              => __( 'Save', '__x__' ),
  'templates-upload'            => __( 'Upload', '__x__' ),
  'templates-title'             => __( 'My Custom Template', '__x__' ),
  'templates-upload-button'     => __( 'Add to layout', '__x__' ),
  'templates-download'          => __( 'Download', '__x__' ),
  'templates-save-library'      => __( 'To Library', '__x__' ),
  'templates-saved'             => __( 'Template saved.', '__x__' ),
  'templates-save-message'      => __( 'How would you like this page stored in your library?', '__x__' ),
  'templates-save-yep'          => __( 'Page', '__x__' ),
  'templates-save-nope'         => __( 'Block', '__x__' ),
  'templates-upload-message'    => __( 'How would you like this added to your page? Remember, using a page will ERASE your current page contents.', '__x__' ),
  'templates-upload-yep'        => __( 'Page', '__x__' ),
  'templates-upload-nope'       => __( 'Block', '__x__' ),
  'templates-upload-start'      => __( 'Your template is being uploaded...', '__x__' ),
  'templates-insert'            => __( 'Insert', '__x__' ),
  'templates-themeco-pages'     => __( 'Themeco Pages', '__x__' ),
  'templates-themeco-blocks'    => __( 'Themeco Blocks', '__x__' ),
  'templates-user-pages'        => __( 'My Pages', '__x__' ),
  'templates-user-blocks'       => __( 'My Blocks', '__x__' ),
  'templates-overwrite-message' => __( 'Using a page will <span style="color: #e74c3c;">erase</span> your current page contents. Are you sure you wish to proceed?', '__x__' ),
  'templates-overwrite-yep'     => __( 'Yep', '__x__' ),
  'templates-overwrite-nope'    => __( 'Nope', '__x__' ),
  'templates-error-read'        => __( 'Unable to read file', '__x__' ),
  'templates-error-upload'      => __( 'Sorry! Your file is not properly formatted.', '__x__' ),
  'templates-error-save'        => __( 'Unable to save template.', '__x__' ),
  'templates-error-import'      => __( 'Could not load template.', '__x__' ),
  'templates-remove-label'      => __( 'Remove Templates', '__x__' ),
  'templates-remove'            => __( 'Delete', '__x__' ),
  'templates-remove-block'      => __( '(Block) %s', '__x__' ),
  'templates-remove-page'       => __( '(Page) %s', '__x__' ),
  'templates-remove-message'    => __( 'Are you sure you wish to delete this template? This can not be undone.', '__x__' ),
  'templates-delete-success'    => __( 'Template removed from library.', '__x__' ),
  'templates-error-delete'      => __( 'Unable to delete stored template.', '__x__' ),
  'templates-page-updated'      => __( 'Page updated.', '__x__' ),
  'templates-block-inserted'      => __( 'Block inserted.', '__x__' ),

  // Inspector
  'inspector-blank-pane-message' => __( 'Click on an element in the site preview to begin inspecting it.', '__x__' ),

  // Controls
  'controls-on'           => __( 'On', '__x__' ),
  'controls-off'          => __( 'Off', '__x__' ),
  'dimensions-top'        => __( 'Top', '__x__' ),
  'dimensions-right'      => __( 'Right', '__x__' ),
  'dimensions-bottom'     => __( 'Bottom', '__x__' ),
  'dimensions-left'       => __( 'Left', '__x__' ),
  'dimensions-link'       => __( 'Link', '__x__' ),
  'dimensions-unlink'     => __( 'Unlink', '__x__' ),
  'tooltip-inspect'       => __( 'Inspect', '__x__' ),
  'tooltip-manage-layout' => __( 'Manage Layout', '__x__' ),
  'tooltip-erase'         => __( 'Erase', '__x__' ),
  'tooltip-copy'          => __( 'Duplicate', '__x__' ),
  'tooltip-delete'        => __( 'Delete', '__x__' ),
  'sortable-add'          => __( 'Add', '__x__' ),
  'sortable-remove'       => __( 'Are you sure you wish to remove this item?', '__x__' ),
  'sortable-at-floor'     => __( 'The last item can&apos;t be deleted, but would you like to reset it to defaults?', '__x__' ),
  'sortable-at-cap'       => __( 'This element has reached its capacity. You can&apos;t add any more.', '__x__' ),
  'sortable-default'      => __( 'New Item %s', '__x__' ),
  'sortable-duplicate'    => __( 'Copy of %s', '__x__' ),
  'sortable-empty'        => __( 'No items!', '__x__' ),
  'sortable-empty-sub'    => __( 'Add some to continue building.', '__x__' ),
  'expand-control'        => __( 'Expand', '__x__' ),

  'settings-format'        => __( '{{type}} Settings', '__x__' ),

  // Settings
  'settings-heading'       => __( 'Settings', '__x__' ),
  'settings-return'        => __( 'Back to Settings', '__x__' ),
  'settings-loading'       => __( 'Please wait while the settings are loaded.', '__x__' ),
  'settings-css-editor'    => __( 'Custom CSS', '__x__' ),
  'settings-js-editor'     => __( 'Custom JS', '__x__' ),
  'settings-js-denied'     => __( 'Your user role does not permit editing javascript.', '__x__' ),
  'settings-js-message'    => __( 'Remember to save to see your script applied.', '__x__' ),
  'settings-wp-changed'    => __( 'You&apos;ve updated a WordPress setting. Please save your page to apply the changes.', '__x__' ),
  'settings-theme-changed' => __( 'You&apos;ve updated a theme setting. Please save your page to apply the changes.', '__x__' ),
  'settings-done'          => __( 'Done', '__x__'),

  // Home
  'home-unsaved'          => __( 'You have not saved any changes!', '__x__' ),
  'home-saved-last'       => __( 'Last saved: %s.', '__x__' ),
  'home-view-site'        => __( 'View Page', '__x__' ),
  'home-dashboard'        => __( 'Dashboard', '__x__' ),
  'home-onbeforeunload'   => __( 'Wait! You have unsaved changes.', '__x__' ),

  // Options
  'options-help-text'             => __( 'Help Text', '__x__' ),
  'options-help-text-sub'         => __( 'Enables tooltips when you hover over control labels and other bits of informational text througout the interface.', '__x__' ),
  'options-editor-position'       => __( 'Editor Position', '__x__' ),
  'options-editor-position-left'  => __( 'Left', '__x__' ),
  'options-editor-position-right' => __( 'Right', '__x__' ),
  'options-editor-position-sub'   => __( 'Move the editor to your preferred side of the window.', '__x__' ),

  // Respond

  'respond-xl-title' => __( 'Extra Large', '__x__' ),
  'respond-lg-title' => __( 'Large', '__x__' ),
  'respond-md-title' => __( 'Medium', '__x__' ),
  'respond-sm-title' => __( 'Small', '__x__' ),
  'respond-xs-title' => __( 'Extra Small', '__x__' ),
  'respond-xl-desc'  => __( '1200px &amp; Up', '__x__' ),
  'respond-lg-desc'  => __( '980px &ndash; 1199px', '__x__' ),
  'respond-md-desc'  => __( '768px &ndash; 979px', '__x__' ),
  'respond-sm-desc'  => __( '481px &ndash; 767px', '__x__' ),
  'respond-xs-desc'  => __( '480px &amp; Smaller', '__x__' ),

  //Confirm
  'confirm-message'                 => __( 'Are you sure?', '__x__' ),
  'confirm-yep'                     => __( 'Yes, proceed', '__x__' ),
  'confirm-nope'                    => __( 'No, go back', '__x__' ),
  'confirm-back'                    => __( 'Back', '__x__' ),

  'confirm-element-delete'          => __( 'Are you sure you wish to delete this %s?', '__x__' ),
  'confirm-element-delete-contents' => __( 'Are you sure you wish to delete this %s, along with its contents?', '__x__' ),

  //Save Complete
  'save-error'             => __( 'Unable to save page.', '__x__' ),
  'save-complete-simple'   => __( 'Content saved.', '__x__' ),
  'save-complete-messages' => array(
    __( 'Woohoo!', '__x__' ),
    __( 'Rock On!', '__x__' ),
    __( 'Radical!', '__x__' ),
    __( 'Tubular!', '__x__' ),
    __( 'Spiffy!', '__x__' ),
    __( 'Yahoo!', '__x__' ),
    __( 'Yippee!', '__x__' ),
    __( 'Have Fun!', '__x__' ),
    __( 'Neat-O!', '__x__' ),
    __( 'Bodacious!', '__x__' ),
    __( 'Scintillating!', '__x__' )
  ),


  // Messaging
  'message-notice'  => __( 'Hey!', '__x__' ),
  'message-success' => __( 'Awesome!', '__x__' ),
  'message-error'   => __( 'Uh oh!', '__x__' ),

  // 'moment-months'         => __( 'January_February_March_April_May_June_July_August_September_October_November_December', '__x__' ),
  // 'moment-months-short'   => __( 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec', '__x__' ),
  // 'moment-weekdays'       => __( 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday', '__x__' ),
  // 'moment-weekdays-short' => __( 'Sun_Mon_Tue_Wed_Thu_Fri_Sat', '__x__' ),
  // 'moment-weekdays-min'   => __( 'Su_Mo_Tu_We_Th_Fr_Sa', '__x__' ),
  'prev-month'            => __( 'Previous Month', '__x__' ),
  'next-month'            => __( 'Next Month', '__x__' ),

  // Errors
  'browser-no-can'            => __( "We're sorry! Your web browser does not support this action.", '__x__' ),
  'no-preview'                => __( "%s (Preview Unsupported)", '__x__' ),
  'preview-failure1'          => __( "An unidentifiable error is preventing the live preview from loading. Switching to Skeleton Mode.", '__x__' ),
  'preview-failure2'          => __( "A suitable content area for the live preview couldn't be identified. Switching to Skeleton Mode.", '__x__' ),
  'skeleton-locked'           => __( "Skeleton Mode can not be closed because the live preview is unavailable.", '__x__' ),
  'preview-late'              => __( "Loading the preview took longer than expected. There may be script conflicts on this page.", '__x__' ),
  'htmlhint-intro'            => __( "We found some invalid HTML in your content.", '__x__' ),
  'htmlhint-tag-pair'         => __( "You have unclosed HTML tags.", '__x__' ),
  'htmlhint-spec-char-escape' => __( "If not part of an HTML tag, consider using HTML entities for angle brackets by converting <span class=\"monospace\">&lt;</span> to <span class=\"monospace\">&amp;lt;</span> and <span class=\"monospace\">&gt;</span> to <span class=\"monospace\">&amp;gt;</span>", '__x__' ),

  // Global Blocks
  'global-blocks.delete-confirm'           => __( 'Are you sure you want to delete this Global Block? This can not be undone.', '__x__' ),
  'global-blocks.no-content'               => __( 'No Global Blocks', '__x__' ),
  'global-blocks.no-content-message'       => __( 'Click "Add New" to create your first Global Block.', '__x__' ),
  'global-blocks.no-content-found'         => __( 'No Global Blocks Found', '__x__' ),
  'global-blocks.no-content-found-message' => __( 'Try refining your search to locate your desired Global Block.', '__x__' ),
);
